VirtualBox

source: vbox/trunk/src/VBox/Installer/linux/install.sh@ 67067

Last change on this file since 67067 was 67054, checked in by vboxsync, 7 years ago

bugref:8834: Makeself installers/Linux: indicate problems better in the exit codes
Detect failure to build kernel modules, to load kernel modules or to replace running kernel modules in the base Makeself installer.

  • Property svn:eol-style set to LF
  • Property svn:keywords set to Author Date Id Revision
File size: 14.7 KB
Line 
1#!/bin/sh
2#
3# Oracle VM VirtualBox
4# VirtualBox linux installation script
5
6#
7# Copyright (C) 2007-2015 Oracle Corporation
8#
9# This file is part of VirtualBox Open Source Edition (OSE), as
10# available from http://www.virtualbox.org. This file is free software;
11# you can redistribute it and/or modify it under the terms of the GNU
12# General Public License (GPL) as published by the Free Software
13# Foundation, in version 2 as it comes in the "COPYING" file of the
14# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
15# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
16#
17
18# Testing:
19# * After successful installation, 0 is returned if the vboxdrv module version
20# built matches the one loaded.
21# * If the kernel modules cannot be built (run the installer with KERN_DIR=/) or
22# loaded (run with KERN_DIR=/lib/modules/<installed non-current version>/build)
23# then 1 is returned.
24
25PATH=$PATH:/bin:/sbin:/usr/sbin
26
27# Include routines and utilities needed by the installer
28. ./routines.sh
29
30LOG="/var/log/vbox-install.log"
31VERSION="_VERSION_"
32SVNREV="_SVNREV_"
33BUILD="_BUILD_"
34ARCH="_ARCH_"
35HARDENED="_HARDENED_"
36# The "BUILD_" prefixes prevent the variables from being overwritten when we
37# read the configuration from the previous installation.
38BUILD_BUILDTYPE="_BUILDTYPE_"
39BUILD_USERNAME="_USERNAME_"
40CONFIG_DIR="/etc/vbox"
41CONFIG="vbox.cfg"
42CONFIG_FILES="filelist"
43DEFAULT_FILES=`pwd`/deffiles
44GROUPNAME="vboxusers"
45INSTALLATION_DIR="_INSTALLATION_DIR_"
46LICENSE_ACCEPTED=""
47PREV_INSTALLATION=""
48PYTHON="_PYTHON_"
49ACTION=""
50SELF=$1
51RC_SCRIPT=0
52if [ -n "$HARDENED" ]; then
53 VBOXDRV_MODE=0600
54 VBOXDRV_GRP="root"
55else
56 VBOXDRV_MODE=0660
57 VBOXDRV_GRP=$GROUPNAME
58fi
59VBOXUSB_MODE=0664
60VBOXUSB_GRP=$GROUPNAME
61
62## Were we able to stop any previously running Additions kernel modules?
63MODULES_STOPPED=1
64
65
66##############################################################################
67# Helper routines #
68##############################################################################
69
70usage() {
71 info ""
72 info "Usage: install | uninstall"
73 info ""
74 info "Example:"
75 info "$SELF install"
76 exit 1
77}
78
79module_loaded() {
80 lsmod | grep -q "vboxdrv[^_-]"
81}
82
83# This routine makes sure that there is no previous installation of
84# VirtualBox other than one installed using this install script or a
85# compatible method. We do this by checking for any of the VirtualBox
86# applications in /usr/bin. If these exist and are not symlinks into
87# the installation directory, then we assume that they are from an
88# incompatible previous installation.
89
90## Helper routine: test for a particular VirtualBox binary and see if it
91## is a link into a previous installation directory
92##
93## Arguments: 1) the binary to search for and
94## 2) the installation directory (if any)
95## Returns: false if an incompatible version was detected, true otherwise
96check_binary() {
97 binary=$1
98 install_dir=$2
99 test ! -e $binary 2>&1 > /dev/null ||
100 ( test -n "$install_dir" &&
101 readlink $binary 2>/dev/null | grep "$install_dir" > /dev/null
102 )
103}
104
105## Main routine
106##
107## Argument: the directory where the previous installation should be
108## located. If this is empty, then we will assume that any
109## installation of VirtualBox found is incompatible with this one.
110## Returns: false if an incompatible installation was found, true otherwise
111check_previous() {
112 install_dir=$1
113 # These should all be symlinks into the installation folder
114 check_binary "/usr/bin/VirtualBox" "$install_dir" &&
115 check_binary "/usr/bin/VBoxManage" "$install_dir" &&
116 check_binary "/usr/bin/VBoxSDL" "$install_dir" &&
117 check_binary "/usr/bin/VBoxVRDP" "$install_dir" &&
118 check_binary "/usr/bin/VBoxHeadless" "$install_dir" &&
119 check_binary "/usr/bin/VBoxDTrace" "$install_dir" &&
120 check_binary "/usr/bin/VBoxBugReport" "$install_dir" &&
121 check_binary "/usr/bin/VBoxBalloonCtrl" "$install_dir" &&
122 check_binary "/usr/bin/VBoxAutostart" "$install_dir" &&
123 check_binary "/usr/bin/vboxwebsrv" "$install_dir" &&
124 check_binary "/usr/bin/vbox-img" "$install_dir" &&
125 check_binary "/sbin/rcvboxdrv" "$install_dir"
126}
127
128##############################################################################
129# Main script #
130##############################################################################
131
132info "VirtualBox Version $VERSION r$SVNREV ($BUILD) installer"
133
134
135# Make sure that we were invoked as root...
136check_root
137
138# Set up logging before anything else
139create_log $LOG
140
141log "VirtualBox $VERSION r$SVNREV installer, built $BUILD."
142log ""
143log "Testing system setup..."
144
145# Sanity check: figure out whether build arch matches uname arch
146cpu=`uname -m`;
147case "$cpu" in
148 i[3456789]86|x86)
149 cpu="x86"
150 ;;
151 x86_64)
152 cpu="amd64"
153 ;;
154esac
155if [ "$cpu" != "$ARCH" ]; then
156 info "Detected unsupported $cpu environment."
157 log "Detected unsupported $cpu environment."
158 exit 1
159fi
160
161# Sensible default actions
162ACTION="install"
163BUILD_MODULE="true"
164while true
165do
166 if [ "$2" = "" ]; then
167 break
168 fi
169 shift
170 case "$1" in
171 install)
172 ACTION="install"
173 ;;
174
175 uninstall)
176 ACTION="uninstall"
177 ;;
178
179 force)
180 FORCE_UPGRADE=1
181 ;;
182 license_accepted_unconditionally)
183 # Legacy option
184 ;;
185 no_module)
186 BUILD_MODULE=""
187 ;;
188 *)
189 if [ "$ACTION" = "" ]; then
190 info "Unknown command '$1'."
191 usage
192 fi
193 info "Specifying an installation path is not allowed -- using _INSTALLATION_DIR_!"
194 ;;
195 esac
196done
197
198if [ "$ACTION" = "install" ]; then
199 # Choose a proper umask
200 umask 022
201
202 # Find previous installation
203 if test -r "$CONFIG_DIR/$CONFIG"; then
204 . $CONFIG_DIR/$CONFIG
205 PREV_INSTALLATION=$INSTALL_DIR
206 fi
207 if ! check_previous $INSTALL_DIR
208 then
209 info
210 info "You appear to have a version of VirtualBox on your system which was installed"
211 info "from a different source or using a different type of installer (or a damaged"
212 info "installation of VirtualBox). We strongly recommend that you remove it before"
213 info "installing this version of VirtualBox."
214 info
215 info "Do you wish to continue anyway? [yes or no]"
216 read reply dummy
217 if ! expr "$reply" : [yY] && ! expr "$reply" : [yY][eE][sS]
218 then
219 info
220 info "Cancelling installation."
221 log "User requested cancellation of the installation"
222 exit 1
223 fi
224 fi
225
226 # Do additional clean-up in case some-one is running from a build folder.
227 ./prerm-common.sh || exit 1
228
229 # Remove previous installation
230 test "${BUILD_MODULE}" = true || VBOX_DONT_REMOVE_OLD_MODULES=1
231
232 if [ -n "$PREV_INSTALLATION" ]; then
233 [ -n "$INSTALL_REV" ] && INSTALL_REV=" r$INSTALL_REV"
234 info "Removing previous installation of VirtualBox $INSTALL_VER$INSTALL_REV from $PREV_INSTALLATION"
235 log "Removing previous installation of VirtualBox $INSTALL_VER$INSTALL_REV from $PREV_INSTALLATION"
236 log ""
237
238 VBOX_NO_UNINSTALL_MESSAGE=1
239 # This also checks $BUILD_MODULE and $VBOX_DONT_REMOVE_OLD_MODULES
240 . ./uninstall.sh
241 fi
242
243 mkdir -p -m 755 $CONFIG_DIR
244 touch $CONFIG_DIR/$CONFIG
245
246 info "Installing VirtualBox to $INSTALLATION_DIR"
247 log "Installing VirtualBox to $INSTALLATION_DIR"
248 log ""
249
250 # Verify the archive
251 mkdir -p -m 755 $INSTALLATION_DIR
252 bzip2 -d -c VirtualBox.tar.bz2 > VirtualBox.tar
253 if ! tar -tf VirtualBox.tar > $CONFIG_DIR/$CONFIG_FILES; then
254 rmdir $INSTALLATION_DIR 2> /dev/null
255 rm -f $CONFIG_DIR/$CONFIG 2> /dev/null
256 rm -f $CONFIG_DIR/$CONFIG_FILES 2> /dev/null
257 log 'Error running "bzip2 -d -c VirtualBox.tar.bz2" or "tar -tf VirtualBox.tar".'
258 abort "Error installing VirtualBox. Installation aborted"
259 fi
260
261 # Create installation directory and install
262 if ! tar -xf VirtualBox.tar -C $INSTALLATION_DIR; then
263 cwd=`pwd`
264 cd $INSTALLATION_DIR
265 rm -f `cat $CONFIG_DIR/$CONFIG_FILES` 2> /dev/null
266 cd $pwd
267 rmdir $INSTALLATION_DIR 2> /dev/null
268 rm -f $CONFIG_DIR/$CONFIG 2> /dev/null
269 log 'Error running "tar -xf VirtualBox.tar -C '"$INSTALLATION_DIR"'".'
270 abort "Error installing VirtualBox. Installation aborted"
271 fi
272
273 cp uninstall.sh $INSTALLATION_DIR
274 echo "uninstall.sh" >> $CONFIG_DIR/$CONFIG_FILES
275
276 # Hardened build: Mark selected binaries set-user-ID-on-execution,
277 # create symlinks for working around unsupported $ORIGIN/.. in VBoxC.so (setuid),
278 # and finally make sure the directory is only writable by the user (paranoid).
279 if [ -n "$HARDENED" ]; then
280 test -e $INSTALLATION_DIR/VirtualBox && chmod 4511 $INSTALLATION_DIR/VirtualBox
281 test -e $INSTALLATION_DIR/VBoxSDL && chmod 4511 $INSTALLATION_DIR/VBoxSDL
282 test -e $INSTALLATION_DIR/VBoxHeadless && chmod 4511 $INSTALLATION_DIR/VBoxHeadless
283 test -e $INSTALLATION_DIR/VBoxNetDHCP && chmod 4511 $INSTALLATION_DIR/VBoxNetDHCP
284 test -e $INSTALLATION_DIR/VBoxNetNAT && chmod 4511 $INSTALLATION_DIR/VBoxNetNAT
285
286 ln -sf $INSTALLATION_DIR/VBoxVMM.so $INSTALLATION_DIR/components/VBoxVMM.so
287 ln -sf $INSTALLATION_DIR/VBoxRT.so $INSTALLATION_DIR/components/VBoxRT.so
288
289 chmod go-w $INSTALLATION_DIR
290 fi
291
292 # This binaries need to be suid root in any case, even if not hardened
293 test -e $INSTALLATION_DIR/VBoxNetAdpCtl && chmod 4511 $INSTALLATION_DIR/VBoxNetAdpCtl
294 test -e $INSTALLATION_DIR/VBoxVolInfo && chmod 4511 $INSTALLATION_DIR/VBoxVolInfo
295
296 # Write the configuration. Needs to be done before the vboxdrv service is
297 # started.
298 echo "# VirtualBox installation directory" > $CONFIG_DIR/$CONFIG
299 echo "INSTALL_DIR='$INSTALLATION_DIR'" >> $CONFIG_DIR/$CONFIG
300 echo "# VirtualBox version" >> $CONFIG_DIR/$CONFIG
301 echo "INSTALL_VER='$VERSION'" >> $CONFIG_DIR/$CONFIG
302 echo "INSTALL_REV='$SVNREV'" >> $CONFIG_DIR/$CONFIG
303 echo "# Build type and user name for logging purposes" >> $CONFIG_DIR/$CONFIG
304 echo "BUILD_TYPE='$BUILD_BUILDTYPE'" >> $CONFIG_DIR/$CONFIG
305 echo "USERNAME='$BUILD_USERNAME'" >> $CONFIG_DIR/$CONFIG
306
307 # Create users group
308 groupadd -r -f $GROUPNAME 2> /dev/null
309
310 # Create symlinks to start binaries
311 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VirtualBox
312 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxManage
313 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxSDL
314 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxVRDP
315 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxHeadless
316 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxBalloonCtrl
317 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxBugReport
318 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxAutostart
319 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/vboxwebsrv
320 ln -sf $INSTALLATION_DIR/vbox-img /usr/bin/vbox-img
321 ln -sf $INSTALLATION_DIR/VBox.png /usr/share/pixmaps/VBox.png
322 if [ -f $INSTALLATION_DIR/VBoxDTrace ]; then
323 ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxDTrace
324 fi
325 # Unity and Nautilus seem to look here for their icons
326 ln -sf $INSTALLATION_DIR/icons/128x128/virtualbox.png /usr/share/pixmaps/virtualbox.png
327 ln -sf $INSTALLATION_DIR/virtualbox.desktop /usr/share/applications/virtualbox.desktop
328 ln -sf $INSTALLATION_DIR/virtualbox.xml /usr/share/mime/packages/virtualbox.xml
329 ln -sf $INSTALLATION_DIR/rdesktop-vrdp /usr/bin/rdesktop-vrdp
330 ln -sf $INSTALLATION_DIR/src/vboxhost /usr/src/vboxhost-_VERSION_
331
332 # Convenience symlinks. The creation fails if the FS is not case sensitive
333 ln -sf VirtualBox /usr/bin/virtualbox > /dev/null 2>&1
334 ln -sf VBoxManage /usr/bin/vboxmanage > /dev/null 2>&1
335 ln -sf VBoxSDL /usr/bin/vboxsdl > /dev/null 2>&1
336 ln -sf VBoxHeadless /usr/bin/vboxheadless > /dev/null 2>&1
337 ln -sf VBoxBugReport /usr/bin/vboxbugreport > /dev/null 2>&1
338 if [ -f $INSTALLATION_DIR/VBoxDTrace ]; then
339 ln -sf VBoxDTrace /usr/bin/vboxdtrace > /dev/null 2>&1
340 fi
341
342 # Create legacy symlinks if necesary for Qt5/xcb stuff.
343 if [ -d $INSTALLATION_DIR/legacy ]; then
344 if ! /sbin/ldconfig -p | grep -q "\<libxcb\.so\.1\>"; then
345 for f in `ls -1 $INSTALLATION_DIR/legacy/`; do
346 ln -s $INSTALLATION_DIR/legacy/$f $INSTALLATION_DIR/$f
347 echo $INSTALLATION_DIR/$f >> $CONFIG_DIR/$CONFIG_FILES
348 done
349 fi
350 fi
351
352 # Icons
353 cur=`pwd`
354 cd $INSTALLATION_DIR/icons
355 for i in *; do
356 cd $i
357 if [ -d /usr/share/icons/hicolor/$i ]; then
358 for j in *; do
359 if expr "$j" : "virtualbox\..*" > /dev/null; then
360 dst=apps
361 else
362 dst=mimetypes
363 fi
364 if [ -d /usr/share/icons/hicolor/$i/$dst ]; then
365 ln -s $INSTALLATION_DIR/icons/$i/$j /usr/share/icons/hicolor/$i/$dst/$j
366 echo /usr/share/icons/hicolor/$i/$dst/$j >> $CONFIG_DIR/$CONFIG_FILES
367 fi
368 done
369 fi
370 cd -
371 done
372 cd $cur
373
374 # Update the MIME database
375 update-mime-database /usr/share/mime 2>/dev/null
376
377 # Update the desktop database
378 update-desktop-database -q 2>/dev/null
379
380 # If Python is available, install Python bindings
381 if [ -n "$PYTHON" ]; then
382 maybe_run_python_bindings_installer $INSTALLATION_DIR $CONFIG_DIR $CONFIG_FILES
383 fi
384
385 # Do post-installation common to all installer types, currently service
386 # script set-up.
387 if test "${BUILD_MODULE}" = "true"; then
388 START_SERVICES=
389 else
390 START_SERVICES="--nostart"
391 fi
392 "${INSTALLATION_DIR}/prerm-common.sh" >> "${LOG}"
393
394 # Now check whether the kernel modules were stopped.
395 lsmod | grep -q vboxdrv && MODULES_STOPPED=
396
397 "${INSTALLATION_DIR}/postinst-common.sh" ${START_SERVICES} >> "${LOG}"
398
399 info ""
400 info "VirtualBox has been installed successfully."
401 info ""
402 info "You will find useful information about using VirtualBox in the user manual"
403 info " $INSTALLATION_DIR/UserManual.pdf"
404 info "and in the user FAQ"
405 info " http://www.virtualbox.org/wiki/User_FAQ"
406 info ""
407 info "We hope that you enjoy using VirtualBox."
408 info ""
409
410 # And do a final test as to whether the kernel modules were properly created
411 # and loaded. Return 0 if both are true, 1 if not.
412 test -n "${MODULES_STOPPED}" &&
413 modinfo vboxdrv >/dev/null 2>&1 &&
414 lsmod | grep -q vboxdrv ||
415 abort "The installation log file is at ${LOG}."
416
417 log "Installation successful"
418elif [ "$ACTION" = "uninstall" ]; then
419 . ./uninstall.sh
420fi
421exit $RC_SCRIPT
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette